﻿Imports System.ComponentModel
Imports System.Globalization
Imports Syncfusion.Data.Extensions

Public Class DisplayMemberConverter
    Implements IValueConverter
    Public Property DisplayMemberPath() As String
        Get
            Return m_DisplayMemberPath
        End Get
        Set
            m_DisplayMemberPath = Value
        End Set
    End Property
    Private m_DisplayMemberPath As String
    Public Property SelectedValuePath() As String
        Get
            Return m_SelectedValuePath
        End Get
        Set
            m_SelectedValuePath = Value
        End Set
    End Property
    Private m_SelectedValuePath As String
    Public Property DataContext() As Object
        Get
            Return m_DataContext
        End Get
        Set
            m_DataContext = Value
        End Set
    End Property
    Private m_DataContext As Object
    Public Function Convert(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.Convert
        Dim selectedValue = value
        Dim list As IEnumerable = Nothing
        Dim displayMemberPath__1 = DisplayMemberPath
        Dim valueMemberPath = SelectedValuePath

        list = TryCast(DataContext, GESTIONE_COMMESSEDataSet).CLIENTI

        If selectedValue Is Nothing Then
            Return Nothing
        End If

        Dim pdc As PropertyDescriptorCollection = Nothing

        If String.IsNullOrEmpty(valueMemberPath) Then
            If Not String.IsNullOrEmpty(displayMemberPath__1) Then
                Dim type = selectedValue.[GetType]()

                pdc = TypeDescriptor.GetProperties(type)

                Return pdc.GetValue(selectedValue, displayMemberPath__1)
            End If
            Return selectedValue
        Else
            If list Is Nothing Then
                Return Nothing
            End If

            Dim enumerator = list.GetEnumerator()
            While enumerator.MoveNext()
                Dim type = enumerator.Current.[GetType]()
                pdc = If(pdc, TypeDescriptor.GetProperties(type))

                If selectedValue.Equals(pdc.GetValue(enumerator.Current, valueMemberPath)) Then
                    If Not String.IsNullOrEmpty(displayMemberPath__1) Then
                        Return pdc.GetValue(enumerator.Current, displayMemberPath__1)
                    End If
                    Return enumerator.Current
                End If
            End While
        End If
        Return Nothing

    End Function

    Public Function ConvertBack(value As Object, targetType As Type, parameter As Object, culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
        Throw New NotImplementedException()
    End Function
End Class
