﻿using Syncfusion.Data;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WpfTestingSample.Model;

namespace WpfTestingSample
{
    class ViewModel:INotifyPropertyChanged
    {
        EmployeeDetails emp = new EmployeeDetails();
       
        #region Constructor

        public ViewModel()
        {
            this.GDCSource = emp;
            companies = new ObservableCollection<CompanyItem>()
                {
                new CompanyItem() { CountryCodeC = "NR", CountryName = "NAURU" },
                new CompanyItem() { CountryCodeC = "NP", CountryName = "NEPAL" },
                new CompanyItem() { CountryCodeC = "NL", CountryName = "NETHERLANDS" },
                new CompanyItem() { CountryCodeC = "NZ", CountryName = "NEW ZEALAND" },
                new CompanyItem() { CountryCodeC = "NI", CountryName = "NICARAGUA" },
                new CompanyItem() { CountryCodeC = "NE", CountryName = "NIGER" },
                new CompanyItem() { CountryCodeC = "NG", CountryName = "NIGERIA" },
                new CompanyItem() { CountryCodeC = "NU", CountryName = "NIUE" }  
                };
        }

        #endregion

        private ObservableCollection<BusinessObjects> gdcsource;
        public ObservableCollection<BusinessObjects> GDCSource
        {
            get
            {
                return gdcsource;
            }
            set
            {
                gdcsource = value;
                OnPropertyChanged("GDCSource");
            }
        }

        private ObservableCollection<CompanyItem> companies;
        public ObservableCollection<CompanyItem> Companies
        {
            get { return companies; }
            set { companies = value; }
        }

        #region INotifyPropertyChanged Members
        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion

    }

    class EmployeeDetails : ObservableCollection<BusinessObjects>
    {
        Random rand = new Random();
        public EmployeeDetails()
        {
            PopulateCollection();
        }

        private void PopulateCollection()
        {
            this.Clear();

            BusinessObjects b = new BusinessObjects() { EmployeeName = "Mart", CountryCode = "NR",  EmployeeAge = 1, EmployeeArea = "101010", EmployeeSalary = 1.7, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Peter", CountryCode = "NP", EmployeeAge = 1, EmployeeArea = "010101", EmployeeSalary = 2.5, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "James", CountryCode = "NL", EmployeeAge = 42, EmployeeArea = "1222111", EmployeeSalary = 18700, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Oliver", CountryCode = "NZ", EmployeeAge = 36, EmployeeArea = "011111", EmployeeSalary = 67000, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Robert", CountryCode = "NI", EmployeeAge = 54, EmployeeArea = "111111", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Suji", CountryCode = "NE", EmployeeAge = 45, EmployeeArea = "11111111", EmployeeSalary = 90000, ExperienceInMonth = 10, EmployeeGender = "Female", EmployeeDate = DateTime.Now };
            this.Add(b);
            b = new BusinessObjects() { EmployeeName = "Mahesh", CountryCode = "NG", EmployeeAge = 48, EmployeeArea = "111111111", EmployeeSalary = 34567, ExperienceInMonth = 10, EmployeeGender = "Male", EmployeeDate = DateTime.Now };
            this.Add(b);
        }
    }

    class CompanyItem:INotifyPropertyChanged
    {
        private string _countryCodeC;
        public string CountryCodeC
        {
            get
            {
                return _countryCodeC;
            }
            set
            {
                _countryCodeC = value;
                OnPropertyChanged("CountryCodeC");
            }
        }

        private string _countryName;
        public string CountryName
        {
            get
            {
                return _countryName;
            }
            set
            {
                _countryName = value;
                OnPropertyChanged("CountryName");
            }
        }

        #region INotifyPropertyChanged Members

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
        }

        #endregion
    }



    public class CustomerInfo : IComparer<Object>, ISortDirection

    {
        public int Compare(object x, object y)
        {
            int namX;
            int namY;

            //For Customers Type data

            if (x.GetType() == typeof(CompanyItem))
            {

                //Calculating the length of CustomerName if the object type is Customers
                namX = ((CompanyItem)x).CountryName.Length;
                namY = ((CompanyItem)y).CountryName.Length;

            }

            //For Group type Data                                   
            else if (x.GetType() == typeof(Group))
            {

                //Calculating the group key length
                namX = ((Group)x).Key.ToString().Length;
                namY = ((Group)y).Key.ToString().Length;
            }
            else
            {
                namX = x.ToString().Length;
                namY = y.ToString().Length;
            }

            // Objects are compared and return the SortDirection
            if (namX.CompareTo(namY) > 0)
                return SortDirection == ListSortDirection.Ascending ? 1 : -1;
            else if (namX.CompareTo(namY) == -1)
                return SortDirection == ListSortDirection.Ascending ? -1 : 1;
            else
                return 0;

        }

        //Get or Set the SortDirection value
        private ListSortDirection _SortDirectioon;
        public ListSortDirection SortDirection
        {
            get { return _SortDirectioon; }
            set { _SortDirectioon = value; }
        }

    }



}
